#include <iostream>

using namespace std;

int main()
{
    int N, zz, zp=0;
    long long br=0;
    cin>>N;
    long long X[N], Y[N], Z[N];
    for(int i=1; i<=N; i++)
        cin>>X[i];
    for(int j=1; j<=N; j++)
        cin>>Y[j];
    cin>>Z[1];
    zz=Z[1];
    if(Z[1]==1)zp++;
    for(int k=2; k<=N; k++)
        {
            cin>>Z[k];
            if(zz!=Z[k])
                zz=Z[k];
            if(Z[k]==k)
                zp++;
        }
         if(zz==Z[1])
    {
            for(int i=1; i<=N; i++)
        {
                for(int j=1; j<=N; j++)
            {
                if(X[i]==Y[j] && zz==j)
                {
                    br+=N;
                }
            }
        }
    }
    else
    {
        for(int i=1; i<=N; i++)
    {
        for(int j=1; j<=N; j++)
        {
            if(X[i]==Y[j])
                for(int k=1; k<=N; k++)
                {
                    if(Z[k]==j)
                        br++;
                }
        }
    }
    }

    cout<<br;
    return 0;
}